From 446756f4c93cd1e8650161bcfb56a7e2e2bb8c56 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 29 2020 05:04:12 +0000
Subject: [PATCH 1855/2232] Indicate that extern type with lifetimes is not implemented yet


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 39ea04e..29013cb 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -337,6 +337,10 @@ fn check_api_type(cx: &mut Check, ety: &ExternType) {
         cx.error(derive, msg);
     }
 
+    if let Some(lifetime) = ety.lifetimes.first() {
+        cx.error(lifetime, "extern type with lifetimes is not supported yet");
+    }
+
     if !ety.bounds.is_empty() {
         let bounds = &ety.bounds;
         let span = quote!(#(#bounds)*);
@@ -440,6 +444,10 @@ fn check_api_type_alias(cx: &mut Check, alias: &TypeAlias) {
         let msg = format!("derive({}) on extern type alias is not supported", derive);
         cx.error(derive, msg);
     }
+
+    if let Some(lifetime) = alias.lifetimes.first() {
+        cx.error(lifetime, "extern type with lifetimes is not supported yet");
+    }
 }
 
 fn check_api_impl(cx: &mut Check, imp: &Impl) {
diff --git a/tests/ui/extern_type_lifetime.rs b/tests/ui/extern_type_lifetime.rs
new file mode 100644
index 0000000..4e0e2f7
--- /dev/null
+++ b/tests/ui/extern_type_lifetime.rs
@@ -0,0 +1,8 @@
+#[cxx::bridge]
+mod ffi {
+    extern "C++" {
+        type Complex<'a, 'b>;
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/extern_type_lifetime.stderr b/tests/ui/extern_type_lifetime.stderr
new file mode 100644
index 0000000..85a5d39
--- /dev/null
+++ b/tests/ui/extern_type_lifetime.stderr
@@ -0,0 +1,5 @@
+error: extern type with lifetimes is not supported yet
+ --> $DIR/extern_type_lifetime.rs:4:22
+  |
+4 |         type Complex<'a, 'b>;
+  |                      ^^

